% A_noiselet.m
%
% Takes noiselet measurements on the specified set.
%
% Written by: Justin Romberg, Georgia Tech, jrom@ece.gatech.edu
% Created: May 2007
%

function y = A_noiseletDCT(x, OMEGA)

N = length(x);
n = sqrt(N);
S = idct2(reshape(x,n,n));
s = S(:);
w = realnoiselet(s)/sqrt(N);
y = w(OMEGA);

