% A_noiselet.m
%
% Takes noiselet measurements on the specified set.
%
% Written by: Justin Romberg, Georgia Tech, jrom@ece.gatech.edu
% Created: May 2007
%

function y = A_noiseletSVD(s, OMEGA, N, U, V)


n = sqrt(N);
S = reshape(s,n,n);

% x = psi* s
X = U*S*V';
x = X(:);

% y = phi x
y_big = realnoiselet(x)/sqrt(N);
y = y_big(OMEGA);


