% Calculates PSNR between original image and noisy version
%
% Written by: Justin Romberg, Georgia Tech
% Created: March 2007

function [snr] = psnr(original, noisy)

[height,width]=size(original);

error = abs(original - noisy);

enorm = sum(sum(error.^2));

snr = 10*log10(255*255*height*width/enorm);
