
%---------------------------------------------------
%--------------- INITIALIZATION --------------------
%---------------------------------------------------

addpath ../CS



measurements = [ 1000 5000:5000:65000];
GraphError =   [0.01   0.02  0.05  0.1   0.2   0.5   1    3   5    10  20  50  100];


%%%%%%%%% Phantom DCT %%%%%%%%%
%GraphEpsilon = [5   5   5   5  5   5   5   5   10   30  100  1000  3000];
%%%%%%%%% Lena DCT %%%%%%%%%
%GraphEpsilon = [50   50   50   50  50   50   50   50   50   50  250  800  3000];
%%%%%%%%% Cameraman DCT %%%%%%%%%
%GraphEpsilon = [50   50   50   50  50   50   50   50   50   80  150  1000  3000];
%%%%%%%%% Text DCT %%%%%%%%%
%GraphEpsilon = [300   300   300   300  300   300   300   300   400   500  500  1500  4000];

%%%%%%%%% Phantom DWT %%%%%%%%%
%GraphEpsilon = [0.01  0.01  0.01   0.01  0.01  0.01  0.05  1  3  30 200 1000 2000];
%%%%%%%%% Lena DWT %%%%%%%%%
GraphEpsilon = [0.5    0.5   0.5   0.5   0.5   0.5   0.5  0.5 5    50  250 1000 2000];
%%%%%%%%% Camera man DWT %%%%%%%%%
% GraphEpsilon = [1       1     1     1     1     1    1    1   3    30  100 1000 2000];
%%%%%%%%% Text DWT %%%%%%%%%
%GraphEpsilon = [5   5   5   5  5   5   5   10   10   80  250  800  1500];

%%%%%%%%% Phantom SVD %%%%%%%%%
%GraphEpsilon = [0.1   0.5   0.8   1  5   10   10   50   100   100  500  1500  2000];
%%%%%%%%% Lena SVD %%%%%%%%%
%GraphEpsilon = [0.01   0.3   0.8    1   5   5   10   50   100   100  350  1500  3000];
%%%%%%%%% Camera man  SVD %%%%%%%%%
%GraphEpsilon = [0.01   0.1   1    1   1   5   10   50   100   100  350  2000  3000];
%%%%%%%%% Text SVD %%%%%%%%%
%GraphEpsilon = [0.01   0.3   0.5    1   1   5   10   50   100   100  500  2000  4000];

%%%%%%%%% Phantom TV %%%%%%%%%
%GraphEpsilon = [0.01  0.01  0.05   0.8  0.8  5 5  10  10  100 150 800 3000];
%%%%%%%%% Lena TV %%%%%%%%%
%GraphEpsilon = [0.01  0.01  0.01   0.01  0.01  0.01  0.01  0.5 5 50 250 1500 4000];
%%%%%%%%% Camera man TV  %%%%%%%%%
%GraphEpsilon = [0.1     0.1  0.1   0.1   0.1   0.1   0.5   1   1    30 150  800  4000];
%%%%%%%%% Text TV %%%%%%%%%
%GraphEpsilon = [0.01  0.01  0.01   0.01  0.01  0.01  0.1  0.1  0.1  1   50 800 3000];


%  ImagName = 'phantom.pgm'
ImagName = 'lena.pgm'
%  ImagName = 'cameraman.tif'
%  ImagName = 'text.pgm'

N = (256^2) % image size



%---------------------------------------------------
%---------------  CALCULATIONS  --------------------
%---------------------------------------------------
for graph =1:13
    count = 1
    GraphError(graph)
    for M = measurements
         %[snr1, y]= cs_l1dct(M , GraphError(graph), GraphEpsilon(graph), ImagName);
         [snr1, y]= cs_l1wav(M , GraphError(graph), GraphEpsilon(graph), ImagName);
         %[snr1, y]= cs_l1svd(M , GraphError(graph), GraphEpsilon(graph), ImagName);
         %[snr1, y]= cs_tv(M , GraphError(graph), GraphEpsilon(graph), ImagName);
         psnr(graph,count) = snr1
         rate(graph, count) = M*entropy(y)/N
         count = count+ 1;
    end;
end;



%---------------------------------------------------
%--------------- PLOTING RESULT --------------------
%---------------------------------------------------

color(1,:) = [1 0 0];
color(2,:) = [1 0.5 0];
color(3,:) = [1 1 0]; 
color(4,:) = [0.5 1 0];
color(5,:) = [0 1 0];
color(6,:) = [0 1 0.5];
color(7,:) = [0 1 1];
color(8,:) = [0 0.8 1];
color(9,:) = [0 0.5  1];
color(10,:) = [0 0  1]; 
color(11,:) = [0.5 0  1];
color(12,:) = [1 0  1];
color(13,:) = [1 0  0.5];



figure;
for i = 1:13
    plot(rate(i,:), psnr(i,:),'Color', color(i,:), 'linewidth', 4);
hold on;
end;


 legend('step = 0.01', 'step = 0.02','step = 0.05' ...
 , 'step = 0.1', 'step = 0.2', 'step = 0.5' ...
 ,'step = 1','step = 3', 'step = 5', 'step = 10', 'step = 20','step = 50', 'step = 100');

grid on;
ylabel 'PSNR'
xlabel 'Rate';  

%axis([0,18,10,100])
